package com.mcmoddev.basemetals.init;

import com.mcmoddev.basemetals.util.Config.Options;
import com.mcmoddev.lib.material.MetalMaterial;

import net.minecraft.item.ItemStack;

/**
 * This class initializes all items in Base Metals.
 *
 * @author Jasmine Iwanek
 *
 */
public class Items extends com.mcmoddev.lib.init.Items {

	private static boolean initDone = false;

	protected Items() {
		throw new IllegalAccessError("Not a instantiable class");
	}

	/**
	 *
	 */
	public static void init() {
		if (initDone) {
			return;
		}

		Blocks.init();
		com.mcmoddev.lib.init.Items.init(); // TODO

		if (Options.enableAdamantine) {
			createItemsFull(Materials.adamantine);
			createItemsModSupport(Materials.adamantine);
		}

		if (Options.enableAntimony) {
			createItemsFull(Materials.antimony);
			createItemsModSupport(Materials.antimony);
		}

		if (Options.enableAquarium) {
			createItemsFull(Materials.aquarium);
		}

		if (Options.enableBismuth) {
			createItemsFull(Materials.bismuth);
			createItemsModSupport(Materials.bismuth);
		}

		if (Options.enableBrass) {
			createItemsFull(Materials.brass);
		}

		if (Options.enableBronze) {
			createItemsFull(Materials.bronze);
		}

		if (Options.enableCharcoal) {
			final MetalMaterial material = Materials.vanilla_charcoal;
			material.ingot = new ItemStack(net.minecraft.init.Items.field_151044_h, 1, 1).func_77973_b();

			createNugget(material);
			createPowder(material);
			createSmallPowder(material);
		}

		if (Options.enableCoal) {
			final MetalMaterial material = Materials.vanilla_coal;
			material.ingot = net.minecraft.init.Items.field_151044_h;

			createNugget(material);
			createPowder(material);
			createSmallPowder(material);
		}

		if (Options.enableColdIron) {
			createItemsFull(Materials.coldiron);
			createItemsModSupport(Materials.coldiron);
		}

		if (Options.enableCopper) {
			createItemsFull(Materials.copper);
		}

		if (Options.enableCupronickel) {
			createItemsFull(Materials.cupronickel);
		}

		if (Options.enableDiamond) {
			final MetalMaterial material = Materials.vanilla_diamond;

			material.axe = net.minecraft.init.Items.field_151056_x;
			material.hoe = net.minecraft.init.Items.field_151012_L;
			material.horse_armor = net.minecraft.init.Items.field_151125_bZ;
			material.pickaxe = net.minecraft.init.Items.field_151046_w;
			material.shovel = net.minecraft.init.Items.field_151047_v;
			material.sword = net.minecraft.init.Items.field_151048_u;
			material.boots = net.minecraft.init.Items.field_151175_af;
			material.chestplate = net.minecraft.init.Items.field_151163_ad;
			material.helmet = net.minecraft.init.Items.field_151161_ac;
			material.leggings = net.minecraft.init.Items.field_151173_ae;
			material.ingot = net.minecraft.init.Items.field_151045_i;

			createItemsFull(material);
		}

		if (Options.enableElectrum) {
			createItemsFull(Materials.electrum);
		}

		if (Options.enableGold) {
			final MetalMaterial material = Materials.vanilla_gold;

			material.axe = net.minecraft.init.Items.field_151006_E;
			material.hoe = net.minecraft.init.Items.field_151013_M;
			material.horse_armor = net.minecraft.init.Items.field_151136_bY;
			material.pickaxe = net.minecraft.init.Items.field_151005_D;
			material.shovel = net.minecraft.init.Items.field_151011_C;
			material.sword = net.minecraft.init.Items.field_151010_B;
			material.boots = net.minecraft.init.Items.field_151151_aj;
			material.chestplate = net.minecraft.init.Items.field_151171_ah;
			material.helmet = net.minecraft.init.Items.field_151169_ag;
			material.leggings = net.minecraft.init.Items.field_151149_ai;
			material.ingot = net.minecraft.init.Items.field_151043_k;
			material.nugget = net.minecraft.init.Items.field_151074_bl;

			createItemsFull(material);
		}

		if (Options.enableInvar) {
			createItemsFull(Materials.invar);
		}

		if (Options.enableIron) {
			final MetalMaterial material = Materials.vanilla_iron;
			material.axe = net.minecraft.init.Items.field_151036_c;
			material.door = net.minecraft.init.Items.field_151139_aw;
			material.hoe = net.minecraft.init.Items.field_151019_K;
			material.horse_armor = net.minecraft.init.Items.field_151138_bX;
			material.pickaxe = net.minecraft.init.Items.field_151035_b;
			material.shovel = net.minecraft.init.Items.field_151037_a;
			material.sword = net.minecraft.init.Items.field_151040_l;
			material.boots = net.minecraft.init.Items.field_151167_ab;
			material.chestplate = net.minecraft.init.Items.field_151030_Z;
			material.helmet = net.minecraft.init.Items.field_151028_Y;
			material.leggings = net.minecraft.init.Items.field_151165_aa;
			material.door = net.minecraft.init.Items.field_151139_aw;
			material.ingot = net.minecraft.init.Items.field_151042_j;
			material.shears = net.minecraft.init.Items.field_151097_aZ;
//			material.nugget = net.minecraft.init.Items.IRON_NUGGET; // Not till after 1.11

			createItemsFull(material);
		}

		if (Options.enableLead) {
			createItemsFull(Materials.lead);
		}

		if (Options.enablePlatinum) {
			createItemsFull(Materials.platinum);
			createItemsModSupport(Materials.platinum);
		}

		if (Options.enableMercury) {
			final MetalMaterial material = Materials.mercury;

			createIngot(material);
			createNugget(material);
			createPowder(material);
			createSmallPowder(material);
		}

		if (Options.enableMithril) {
			createItemsFull(Materials.mithril);
		}

		if (Options.enableNickel) {
			createItemsFull(Materials.nickel);
			createItemsModSupport(Materials.nickel);
		}

		if (Options.enablePewter) {
			createItemsFull(Materials.pewter);
		}

		if (Options.enableSilver) {
			createItemsFull(Materials.silver);
		}

		if (Options.enableStarSteel) {
			createItemsFull(Materials.starsteel);
			createItemsModSupport(Materials.starsteel);
		}

		if (Options.enableStone) {
			final MetalMaterial material = Materials.vanilla_stone;

			material.axe = net.minecraft.init.Items.field_151049_t;
			material.hoe = net.minecraft.init.Items.field_151018_J;
			material.pickaxe = net.minecraft.init.Items.field_151050_s;
			material.shovel = net.minecraft.init.Items.field_151051_r;
			material.sword = net.minecraft.init.Items.field_151052_q;
			material.block = net.minecraft.init.Blocks.field_150348_b;
			material.half_slab = net.minecraft.init.Blocks.field_150333_U;
			material.double_slab = net.minecraft.init.Blocks.field_150334_T;
			material.stairs = net.minecraft.init.Blocks.field_150446_ar;

			createCrackhammer(material);
			createRod(material);
			createGear(material);
		}

		if (Options.enableSteel) {
			createItemsFull(Materials.steel);
		}

		if (Options.enableTin) {
			createItemsFull(Materials.tin);
		}

		if (Options.enableWood) {
			final MetalMaterial material = Materials.vanilla_wood;

			material.axe = net.minecraft.init.Items.field_151053_p;
			material.door = net.minecraft.init.Items.field_179570_aq;
			material.hoe = net.minecraft.init.Items.field_151017_I;
			material.pickaxe = net.minecraft.init.Items.field_151039_o;
			material.shovel = net.minecraft.init.Items.field_151038_n;
			material.sword = net.minecraft.init.Items.field_151041_m;
			material.doorBlock = net.minecraft.init.Blocks.field_180413_ao;
			material.ore = net.minecraft.init.Blocks.field_150364_r;
			material.trapdoor = net.minecraft.init.Blocks.field_150415_aT;
			material.shears = net.minecraft.init.Items.field_151097_aZ;
			material.block = net.minecraft.init.Blocks.field_150344_f;
			material.half_slab = net.minecraft.init.Blocks.field_150376_bx;
			material.double_slab = net.minecraft.init.Blocks.field_150373_bw;
			material.stairs = net.minecraft.init.Blocks.field_150476_ad;

			createCrackhammer(material);
			createGear(material);
		}

		if (Options.enableZinc) {
			createItemsFull(Materials.zinc);
			createItemsModSupport(Materials.zinc);
		}

		addToMetList(); // TODO
		
		initDone = true;
	}
}
