package com.mcmoddev.lib.asm;

import com.google.common.base.Optional;
import com.mcmoddev.lib.common.item.IHorseArmor;

import net.minecraft.entity.passive.EntityHorse;
import net.minecraft.entity.passive.HorseArmorType;
import net.minecraft.item.ItemStack;
import net.minecraft.network.datasync.DataParameter;
import net.minecraft.network.datasync.DataSerializers;
import net.minecraft.network.datasync.EntityDataManager;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class ASMHooks {

	public static final DataParameter<Optional<ItemStack>> ARMOR_STACK = EntityDataManager.func_187226_a(EntityHorse.class, DataSerializers.field_187196_f);

	private ASMHooks() {
		throw new IllegalAccessError("Not a instantiable class");
	}

	public static void onInitHorse(EntityHorse entity) {
		entity.func_184212_Q().func_187214_a(ASMHooks.ARMOR_STACK, Optional.absent());
	}

	public static void setHorseArmorStack(EntityHorse entity, ItemStack stack) {
		entity.func_184212_Q().func_187227_b(ASMHooks.ARMOR_STACK, Optional.fromNullable(stack));
	}

	@SideOnly(Side.CLIENT)
	public static String getTextureName(HorseArmorType type, EntityHorse entity) {
		final ItemStack stack = entity.func_184212_Q().func_187225_a(ASMHooks.ARMOR_STACK).orNull();
		if (stack != null && stack.func_77973_b() instanceof IHorseArmor)
			return ((IHorseArmor) stack.func_77973_b()).getArmorTexture(entity, stack);
		return type.func_188574_d();
	}
}
