package com.mcmoddev.lib.blocks;

import com.mcmoddev.basemetals.registry.IOreDictionaryEntry;
import com.mcmoddev.lib.material.IMetalObject;
import com.mcmoddev.lib.material.MetalMaterial;
import com.mcmoddev.lib.util.Oredicts;

import net.minecraft.block.BlockButton;
import net.minecraft.block.SoundType;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class BlockButtonMetal extends BlockButton implements IOreDictionaryEntry, IMetalObject {

	final MetalMaterial material;
	private final String oreDict;

	public BlockButtonMetal(MetalMaterial material) {
		super(false);
		this.func_149672_a(SoundType.field_185852_e);
		this.material = material;
		this.oreDict = Oredicts.BUTTON + this.material.getCapitalizedName();
		this.field_149782_v = material.getMetalBlockHardness();
		this.field_149781_w = material.getBlastResistance();
		this.setHarvestLevel("pickaxe", material.getRequiredHarvestLevel());
	}

	@Override
	protected void func_185615_a(EntityPlayer player, World worldIn, BlockPos pos) {
		worldIn.func_184133_a(player, pos, SoundEvents.field_187839_fV, SoundCategory.BLOCKS, 0.3F, 0.6F);
	}

	@Override
	protected void func_185617_b(World worldIn, BlockPos pos) {
		worldIn.func_184133_a((EntityPlayer) null, pos, SoundEvents.field_187837_fU, SoundCategory.BLOCKS, 0.3F, 0.5F);
	}

	@Override
	public MetalMaterial getMaterial() {
		return this.material;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public MetalMaterial getMetalMaterial() {
		return this.material;
	}

	@Override
	public String getOreDictionaryName() {
		return this.oreDict;
	}
}
