package com.mcmoddev.lib.blocks;

import com.mcmoddev.basemetals.init.Achievements;
import com.mcmoddev.basemetals.registry.IOreDictionaryEntry;
import com.mcmoddev.basemetals.util.Config.Options;
import com.mcmoddev.lib.material.IMetalObject;
import com.mcmoddev.lib.material.MetalMaterial;
import com.mcmoddev.lib.util.Oredicts;

import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

/**
 * Metal Block
 */
public class BlockMetalBlock extends Block implements IOreDictionaryEntry, IMetalObject {

	private final MetalMaterial material;
	private final String oreDict;

	/**
	 *
	 * @param material The material the block is made from
	 */
	public BlockMetalBlock(MetalMaterial material) {
		this(material, false);
	}

	public BlockMetalBlock(MetalMaterial material, boolean glows) {
		super(Material.field_151573_f);
		this.func_149672_a(SoundType.field_185852_e);
		this.field_149787_q = true;
		this.field_149786_r = 255;
		this.field_149785_s = false;
		this.material = material;
		this.func_149647_a(CreativeTabs.field_78030_b);
		this.oreDict = Oredicts.BLOCK + material.getCapitalizedName();
		this.field_149782_v = material.getMetalBlockHardness();
		this.field_149781_w = material.getBlastResistance();
		this.setHarvestLevel("pickaxe", material.getRequiredHarvestLevel());
		if (glows)
			this.func_149715_a(0.5f);
	}

	///// OVERRIDE OF ALL METHODS THAT DEPEND ON BLOCK MATERIAL: /////
	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public MapColor func_180659_g(final IBlockState bs) {
		return MapColor.field_151668_h;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public boolean func_149730_j(IBlockState bs) {
		return true;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public boolean func_149721_r(IBlockState bs) {
		return true;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public boolean func_185481_k(IBlockState bs) {
		return true;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public boolean func_149686_d(IBlockState bs) {
		return true;
	}

	@Override
	public boolean func_176205_b(final IBlockAccess worldIn, final BlockPos pos) {
		return false;
	}

	@Override
	public boolean func_176200_f(final IBlockAccess w, final BlockPos p) {
		return false;
	}

	@Override
	public boolean isNormalCube(final IBlockState bs, final IBlockAccess w, final BlockPos coord) {
		return true;
	}

	@Override
	public void func_180633_a(final World w, final BlockPos coord, final IBlockState bs,
			final EntityLivingBase placer, final ItemStack src) {
		super.func_180633_a(w, coord, bs, placer, src);
		// achievement
		if ((Options.enableAchievements) && (placer instanceof EntityPlayer)) {
				((EntityPlayer) placer).func_71064_a(Achievements.blocktastic, 1);
		}
	}

	@Override
	public String getOreDictionaryName() {
		return this.oreDict;
	}

	@Override
	public MetalMaterial getMaterial() {
		return this.material;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public MetalMaterial getMetalMaterial() {
		return this.material;
	}
}
