package com.mcmoddev.lib.blocks;

import java.util.Random;

import com.mcmoddev.lib.material.IMetalObject;
import com.mcmoddev.lib.material.MetalMaterial;

import net.minecraft.block.BlockDoor;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.minecraft.block.BlockDoor.EnumDoorHalf;

/**
 * Door Block
 *
 * @author DrCyano
 *
 */
public class BlockMetalDoor extends net.minecraft.block.BlockDoor implements IMetalObject {

	private final MetalMaterial material;

	/**
	 *
	 * @param material The material the door is made from
	 */
	public BlockMetalDoor(MetalMaterial material) {
		super((material.getToolHarvestLevel() > 0) ? Material.field_151573_f : Material.field_151576_e);
		this.func_149672_a(SoundType.field_185852_e);
		this.material = material;
		this.field_149782_v = material.getMetalBlockHardness();
		this.field_149781_w = material.getBlastResistance();
		this.setHarvestLevel("pickaxe", material.getRequiredHarvestLevel());
		this.func_149649_H();
	}

	/**
	 * @deprecated
	 */
	@SideOnly(Side.CLIENT)
	@Override
	@Deprecated
	public ItemStack func_185473_a(final World w, final BlockPos c, final IBlockState bs) {
		return new ItemStack(this.material.door);
	}

	@Override
	public Item func_180660_a(final IBlockState state, final Random rand, final int fortune) {
		return (state.func_177229_b(BlockDoor.field_176523_O) == EnumDoorHalf.UPPER) ? null : this.material.door;
	}

	@Override
	public boolean func_180639_a(final World world, final BlockPos coord, IBlockState blockstate,
									final EntityPlayer player,
									final EnumHand hand, ItemStack heldItem,
									final EnumFacing face,
									final float partialX, final float partialY, final float partialZ) {
		if (this.material.getToolHarvestLevel() > 1)
			return false;
		final BlockPos pos = (blockstate.func_177229_b(BlockDoor.field_176523_O) == EnumDoorHalf.LOWER) ? coord : coord.func_177977_b();
		final IBlockState bs = coord.equals(pos) ? blockstate : world.func_180495_p(pos);
		if (bs.func_177230_c() != this)
			return false;
		blockstate = bs.func_177231_a(BlockDoor.field_176519_b);
		world.func_180501_a(pos, blockstate, 2);
		world.func_175704_b(pos, coord);
		world.func_180498_a(player, ((Boolean) blockstate.func_177229_b(BlockDoor.field_176519_b)) ? 1003 : 1006, coord, 0);
		return true;
	}

	@Override
	public MetalMaterial getMaterial() {
		return this.material;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public MetalMaterial getMetalMaterial() {
		return this.material;
	}
}
