package com.mcmoddev.lib.blocks;

import com.mcmoddev.lib.material.IMetalObject;
import com.mcmoddev.lib.material.MetalMaterial;

import net.minecraft.block.BlockPressurePlate;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;

/**
 *
 * @author Jasmine Iwanek
 *
 */
public class BlockMetalPressurePlate extends BlockPressurePlate implements IMetalObject {

	final MetalMaterial material;

	/**
	 *
	 * @param material The material the pressure plate is made from
	 */
	public BlockMetalPressurePlate(MetalMaterial material) {
		super(Material.field_151573_f, BlockPressurePlate.Sensitivity.MOBS);
		this.func_149672_a(SoundType.field_185852_e);
		this.material = material;
		this.field_149782_v = material.getMetalBlockHardness();
		this.field_149781_w = material.getBlastResistance();
		this.setHarvestLevel("pickaxe", material.getRequiredHarvestLevel());
	}

	@Override
	public MetalMaterial getMaterial() {
		return this.material;
	}

	/**
	 * @deprecated
	 */
	@Override
	@Deprecated
	public MetalMaterial getMetalMaterial() {
		return this.material;
	}
}
