package com.mcmoddev.lib.entity;

import com.mcmoddev.basemetals.init.Materials;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.projectile.EntityTippedArrow;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;

/**
 *
 * @author Jasmine Iwanek
 *
 */
public class EntityCustomBolt extends EntityTippedArrow {

	private ItemStack itemStack;

	/**
	 *
	 * @param worldIn The World
	 */
	public EntityCustomBolt(World worldIn) {
		super(worldIn);
	}

	/**
	 *
	 * @param worldIn The World
	 * @param x X
	 * @param y Y
	 * @param z Z
	 */
	public EntityCustomBolt(World worldIn, double x, double y, double z) {
		super(worldIn, x, y, z);
	}

	/**
	 *
	 * @param worldIn The World
	 * @param stack The ItemStack
	 * @param shooter The Shooter
	 */
	public EntityCustomBolt(World worldIn, ItemStack stack, EntityPlayer shooter) {
		super(worldIn, shooter);
		this.itemStack = stack;
	}

	@Override
	protected ItemStack func_184550_j() {
		return this.getBoltStack();
	}

	protected ItemStack getBoltStack() {
		if (this.itemStack == null) {
			// TODO: FIXME
			this.itemStack = new ItemStack(Materials.vanilla_wood.bolt);
		}

		return new ItemStack(this.itemStack.func_77973_b(), 1, this.itemStack.func_77952_i());
	}

	@Override
	public NBTTagCompound func_189511_e(NBTTagCompound compound) {
		super.func_189511_e(compound);

		final NBTTagCompound itemStackCompound = new NBTTagCompound();
		this.itemStack.func_77955_b(itemStackCompound);

		compound.func_74782_a("itemstack", itemStackCompound);

		return compound;
	}

	@Override
	public void func_70020_e(NBTTagCompound compound) {
		super.func_70020_e(compound);

		this.itemStack = ItemStack.func_77949_a(compound.func_74775_l("itemstack"));
	}
}
