package com.mcmoddev.lib.entity.projectile;

import java.util.List;

import com.mcmoddev.lib.items.ItemFishingRod;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.item.EntityXPOrb;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.network.datasync.DataParameter;
import net.minecraft.network.datasync.DataSerializers;
import net.minecraft.network.datasync.EntityDataManager;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraft.world.storage.loot.LootContext;
import net.minecraft.world.storage.loot.LootTableList;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

/**
 *
 * @author Jasmine Iwanek
 *
 */
public class EntityFishHook extends net.minecraft.entity.projectile.EntityFishHook {

	private static final DataParameter<Integer> DATA_HOOKED_ENTITY = EntityDataManager.<Integer>func_187226_a(EntityFishHook.class, DataSerializers.field_187192_b);
	private Block inTile;
	private boolean inGround;
	private int ticksInGround;
	private int ticksInAir;
	private int ticksCatchable;
	private int ticksCaughtDelay;
	private int ticksCatchableDelay;
	private float fishApproachAngle;
	private int fishPosRotationIncrements;
	private double fishX;
	private double fishY;
	private double fishZ;
	private double fishYaw;
	private double fishPitch;
	@SideOnly(Side.CLIENT)
	private double clientMotionX;
	@SideOnly(Side.CLIENT)
	private double clientMotionY;
	@SideOnly(Side.CLIENT)
	private double clientMotionZ;

	/**
	 *
	 * @param worldIn The World
	 */
	public EntityFishHook(World worldIn) {
		super(worldIn);
	}

	/**
	 *
	 * @param worldIn The World
	 * @param x X
	 * @param y Y
	 * @param z Z
	 * @param anglerIn The bobber
	 */
	@SideOnly(Side.CLIENT)
	public EntityFishHook(World worldIn, double x, double y, double z, EntityPlayer anglerIn) {
		super(worldIn, x, y, z, anglerIn);
	}

	/**
	 *
	 * @param worldIn The World
	 * @param fishingPlayer The player
	 */
	public EntityFishHook(World worldIn, EntityPlayer fishingPlayer) {
		super(worldIn, fishingPlayer);
	}

	// Do we need to override this?
	@Override
	protected void func_70088_a() {
		this.func_184212_Q().func_187214_a(DATA_HOOKED_ENTITY, Integer.valueOf(0));
	}

	// Do we need to override this?
	@Override
	public void func_184206_a(DataParameter<?> key) {
		if (DATA_HOOKED_ENTITY.equals(key)) {
			final int i = ((Integer) this.func_184212_Q().func_187225_a(DATA_HOOKED_ENTITY)).intValue();

			if ((i > 0) && (this.field_146043_c != null)) {
				this.field_146043_c = null;
			}
		}

		super.func_184206_a(key);
	}

	/**
	 * Called to update the entity's position/logic.
	 */
	@Override
	public void func_70071_h_() {
		// super.onUpdate();

		if (!this.field_70170_p.field_72995_K)
			this.func_70052_a(6, this.func_184202_aL());

		this.func_70030_z();

		if (this.field_70170_p.field_72995_K) {
			final int i = ((Integer) this.func_184212_Q().func_187225_a(DATA_HOOKED_ENTITY)).intValue();

			if ((i > 0) && (this.field_146043_c == null)) {
				this.field_146043_c = this.field_70170_p.func_73045_a(i - 1);
			}
		} else {
			final ItemStack itemstack = this.field_146042_b.func_184614_ca();

			// We had to change this due to hardcoding
			if (this.field_146042_b.field_70128_L || !this.field_146042_b.func_70089_S() || (itemstack == null) || !(itemstack.func_77973_b() instanceof ItemFishingRod) || (this.func_70068_e(this.field_146042_b) > 1024.0D)) {
				this.func_70106_y();
				this.field_146042_b.field_71104_cf = null;
				return;
			}
		}

		if (this.field_146043_c != null) {
			if (!this.field_146043_c.field_70128_L) {
				this.field_70165_t = this.field_146043_c.field_70165_t;
				final double d17 = (double) this.field_146043_c.field_70131_O;
				this.field_70163_u = this.field_146043_c.func_174813_aQ().field_72338_b + (d17 * 0.8D);
				this.field_70161_v = this.field_146043_c.field_70161_v;
				return;
			}

			this.field_146043_c = null;
		}

		if (this.fishPosRotationIncrements > 0) {
			final double d3 = this.field_70165_t + ((this.fishX - this.field_70165_t) / (double) this.fishPosRotationIncrements);
			final double d4 = this.field_70163_u + ((this.fishY - this.field_70163_u) / (double) this.fishPosRotationIncrements);
			final double d6 = this.field_70161_v + ((this.fishZ - this.field_70161_v) / (double) this.fishPosRotationIncrements);
			final double d8 = MathHelper.func_76138_g(this.fishYaw - (double) this.field_70177_z);
			this.field_70177_z = (float) ((double) this.field_70177_z + (d8 / (double) this.fishPosRotationIncrements));
			this.field_70125_A = (float) ((double) this.field_70125_A + ((this.fishPitch - (double) this.field_70125_A) / (double) this.fishPosRotationIncrements));
			--this.fishPosRotationIncrements;
			this.func_70107_b(d3, d4, d6);
			this.func_70101_b(this.field_70177_z, this.field_70125_A);
		} else {
			if (this.inGround) {
				// TODO: Differs
				if (this.field_70170_p.func_180495_p(new BlockPos(this.field_70165_t, this.field_70163_u, this.field_70161_v)).func_177230_c() == this.inTile) {
					++this.ticksInGround;

					if (this.ticksInGround == 1200) {
						this.func_70106_y();
					}

					return;
				}

				this.inGround = false;
				this.field_70159_w *= (double) (this.field_70146_Z.nextFloat() * 0.2F);
				this.field_70181_x *= (double) (this.field_70146_Z.nextFloat() * 0.2F);
				this.field_70179_y *= (double) (this.field_70146_Z.nextFloat() * 0.2F);
				this.ticksInGround = 0;
				this.ticksInAir = 0;
			} else {
				++this.ticksInAir;
			}

			if (!this.field_70170_p.field_72995_K) {
				Vec3d vec3d1 = new Vec3d(this.field_70165_t, this.field_70163_u, this.field_70161_v);
				Vec3d vec3d = new Vec3d(this.field_70165_t + this.field_70159_w, this.field_70163_u + this.field_70181_x, this.field_70161_v + this.field_70179_y);
				RayTraceResult raytraceresult = this.field_70170_p.func_72933_a(vec3d1, vec3d);
				vec3d1 = new Vec3d(this.field_70165_t, this.field_70163_u, this.field_70161_v);
				vec3d = new Vec3d(this.field_70165_t + this.field_70159_w, this.field_70163_u + this.field_70181_x, this.field_70161_v + this.field_70179_y);

				if (raytraceresult != null) {
					vec3d = new Vec3d(raytraceresult.field_72307_f.field_72450_a, raytraceresult.field_72307_f.field_72448_b, raytraceresult.field_72307_f.field_72449_c);
				}

				Entity entity = null;
				final List<Entity> list = this.field_70170_p.func_72839_b(this, this.func_174813_aQ().func_72321_a(this.field_70159_w, this.field_70181_x, this.field_70179_y).func_186662_g(1.0D));
				double d0 = 0.0D;

				for (int j = 0; j < list.size(); ++j) {
					final Entity entity1 = (Entity) list.get(j);

					if (entity1.func_70067_L() && ((entity1 != this.field_146042_b) || (this.ticksInAir >= 5))) {
						final AxisAlignedBB axisalignedbb1 = entity1.func_174813_aQ().func_186662_g(0.30000001192092896D);
						final RayTraceResult raytraceresult1 = axisalignedbb1.func_72327_a(vec3d1, vec3d);

						if (raytraceresult1 != null) {
							final double d1 = vec3d1.func_72436_e(raytraceresult1.field_72307_f);

							if ((d1 < d0) || (d0 == 0.0D)) {
								entity = entity1;
								d0 = d1;
							}
						}
					}
				}

				if (entity != null) {
					raytraceresult = new RayTraceResult(entity);
				}

				if (raytraceresult != null) {
					if (raytraceresult.field_72308_g != null) {
						this.field_146043_c = raytraceresult.field_72308_g;
						this.func_184212_Q().func_187227_b(DATA_HOOKED_ENTITY, Integer.valueOf(this.field_146043_c.func_145782_y() + 1));
					} else {
						this.inGround = true;
					}
				}
			}

			if (!this.inGround) {
				this.func_70091_d(this.field_70159_w, this.field_70181_x, this.field_70179_y);
				final float f2 = MathHelper.func_76133_a((this.field_70159_w * this.field_70159_w) + (this.field_70179_y * this.field_70179_y));
				this.field_70177_z = (float) (MathHelper.func_181159_b(this.field_70159_w, this.field_70179_y) * (180D / Math.PI));

				for (this.field_70125_A = (float) (MathHelper.func_181159_b(this.field_70181_x, (double) f2) * (180D / Math.PI)); (this.field_70125_A - this.field_70127_C) < -180.0F; this.field_70127_C -= 360.0F) {
					;
				}

				while ((this.field_70125_A - this.field_70127_C) >= 180.0F) {
					this.field_70127_C += 360.0F;
				}

				while ((this.field_70177_z - this.field_70126_B) < -180.0F) {
					this.field_70126_B -= 360.0F;
				}

				while ((this.field_70177_z - this.field_70126_B) >= 180.0F) {
					this.field_70126_B += 360.0F;
				}

				this.field_70125_A = this.field_70127_C + ((this.field_70125_A - this.field_70127_C) * 0.2F);
				this.field_70177_z = this.field_70126_B + ((this.field_70177_z - this.field_70126_B) * 0.2F);
				float f3 = 0.92F;

				if (this.field_70122_E || this.field_70123_F) {
					f3 = 0.5F;
				}

				// final int k = 5;
				double d5 = 0.0D;

				for (int l = 0; l < 5; ++l) {
					final AxisAlignedBB axisalignedbb = this.func_174813_aQ();
					final double d9 = axisalignedbb.field_72337_e - axisalignedbb.field_72338_b;
					final double d10 = axisalignedbb.field_72338_b + ((d9 * (double) l) / 5.0D);
					final double d11 = axisalignedbb.field_72338_b + ((d9 * (double) (l + 1)) / 5.0D);
					final AxisAlignedBB axisalignedbb2 = new AxisAlignedBB(axisalignedbb.field_72340_a, d10, axisalignedbb.field_72339_c, axisalignedbb.field_72336_d, d11, axisalignedbb.field_72334_f);

					if (this.field_70170_p.func_72830_b(axisalignedbb2, Material.field_151586_h)) {
						d5 += 0.2D;
					}
				}

				if (!this.field_70170_p.field_72995_K && (d5 > 0.0D)) {
					final WorldServer worldserver = (WorldServer) this.field_70170_p;
					int i1 = 1;
					final BlockPos blockpos = (new BlockPos(this)).func_177984_a();

					if ((this.field_70146_Z.nextFloat() < 0.25F) && this.field_70170_p.func_175727_C(blockpos)) {
						i1 = 2;
					}

					if ((this.field_70146_Z.nextFloat() < 0.5F) && !this.field_70170_p.func_175678_i(blockpos)) {
						--i1;
					}

					if (this.ticksCatchable > 0) {
						--this.ticksCatchable;

						if (this.ticksCatchable <= 0) {
							this.ticksCaughtDelay = 0;
							this.ticksCatchableDelay = 0;
						}
					} else if (this.ticksCatchableDelay > 0) {
						this.ticksCatchableDelay -= i1;

						if (this.ticksCatchableDelay <= 0) {
							this.field_70181_x -= 0.20000000298023224D;
							this.func_184185_a(SoundEvents.field_187609_F, 0.25F, 1.0F + ((this.field_70146_Z.nextFloat() - this.field_70146_Z.nextFloat()) * 0.4F));
							final float f6 = (float) MathHelper.func_76128_c(this.func_174813_aQ().field_72338_b);
							worldserver.func_175739_a(EnumParticleTypes.WATER_BUBBLE, this.field_70165_t, (double) (f6 + 1.0F), this.field_70161_v, (int) (1.0F + (this.field_70130_N * 20.0F)), (double) this.field_70130_N, 0.0D, (double) this.field_70130_N, 0.20000000298023224D, new int[0]);
							worldserver.func_175739_a(EnumParticleTypes.WATER_WAKE, this.field_70165_t, (double) (f6 + 1.0F), this.field_70161_v, (int) (1.0F + (this.field_70130_N * 20.0F)), (double) this.field_70130_N, 0.0D, (double) this.field_70130_N, 0.20000000298023224D, new int[0]);
							this.ticksCatchable = MathHelper.func_76136_a(this.field_70146_Z, 10, 30);
						} else {
							this.fishApproachAngle = (float) ((double) this.fishApproachAngle + (this.field_70146_Z.nextGaussian() * 4.0D));
							final float f5 = this.fishApproachAngle * 0.017453292F;
							final float f8 = MathHelper.func_76126_a(f5);
							final float f10 = MathHelper.func_76134_b(f5);
							final double d13 = this.field_70165_t + (double) (f8 * (float) this.ticksCatchableDelay * 0.1F);
							final double d15 = (double) ((float) MathHelper.func_76128_c(this.func_174813_aQ().field_72338_b) + 1.0F);
							final double d16 = this.field_70161_v + (double) (f10 * (float) this.ticksCatchableDelay * 0.1F);
							final Block block1 = worldserver.func_180495_p(new BlockPos((int) d13, (int) d15 - 1, (int) d16)).func_177230_c();

							if ((block1 == Blocks.field_150355_j) || (block1 == Blocks.field_150358_i)) {
								if (this.field_70146_Z.nextFloat() < 0.15F) {
									worldserver.func_175739_a(EnumParticleTypes.WATER_BUBBLE, d13, d15 - 0.10000000149011612D, d16, 1, (double) f8, 0.1D, (double) f10, 0.0D, new int[0]);
								}

								final float f = f8 * 0.04F;
								final float f1 = f10 * 0.04F;
								worldserver.func_175739_a(EnumParticleTypes.WATER_WAKE, d13, d15, d16, 0, (double) f1, 0.01D, (double) (-f), 1.0D, new int[0]);
								worldserver.func_175739_a(EnumParticleTypes.WATER_WAKE, d13, d15, d16, 0, (double) (-f1), 0.01D, (double) f, 1.0D, new int[0]);
							}
						}
					} else if (this.ticksCaughtDelay > 0) {
						this.ticksCaughtDelay -= i1;
						float f4 = 0.15F;

						if (this.ticksCaughtDelay < 20) {
							f4 = (float) ((double) f4 + ((double) (20 - this.ticksCaughtDelay) * 0.05D));
						} else if (this.ticksCaughtDelay < 40) {
							f4 = (float) ((double) f4 + ((double) (40 - this.ticksCaughtDelay) * 0.02D));
						} else if (this.ticksCaughtDelay < 60) {
							f4 = (float) ((double) f4 + ((double) (60 - this.ticksCaughtDelay) * 0.01D));
						}

						if (this.field_70146_Z.nextFloat() < f4) {
							final float f7 = MathHelper.func_151240_a(this.field_70146_Z, 0.0F, 360.0F) * 0.017453292F;
							final float f9 = MathHelper.func_151240_a(this.field_70146_Z, 25.0F, 60.0F);
							final double d12 = this.field_70165_t + (double) (MathHelper.func_76126_a(f7) * f9 * 0.1F);
							final double d14 = (double) ((float) MathHelper.func_76128_c(this.func_174813_aQ().field_72338_b) + 1.0F);
							final double d2 = this.field_70161_v + (double) (MathHelper.func_76134_b(f7) * f9 * 0.1F);
							final Block block = worldserver.func_180495_p(new BlockPos((int) d12, (int) d14 - 1, (int) d2)).func_177230_c();

							if ((block == Blocks.field_150355_j) || (block == Blocks.field_150358_i)) {
								worldserver.func_175739_a(EnumParticleTypes.WATER_SPLASH, d12, d14, d2, 2 + this.field_70146_Z.nextInt(2), 0.10000000149011612D, 0.0D, 0.10000000149011612D, 0.0D, new int[0]);
							}
						}

						if (this.ticksCaughtDelay <= 0) {
							this.fishApproachAngle = MathHelper.func_151240_a(this.field_70146_Z, 0.0F, 360.0F);
							this.ticksCatchableDelay = MathHelper.func_76136_a(this.field_70146_Z, 20, 80);
						}
					} else {
						this.ticksCaughtDelay = MathHelper.func_76136_a(this.field_70146_Z, 100, 900);
						this.ticksCaughtDelay -= EnchantmentHelper.func_151387_h(this.field_146042_b) * 20 * 5;
					}

					if (this.ticksCatchable > 0) {
						this.field_70181_x -= (double) (this.field_70146_Z.nextFloat() * this.field_70146_Z.nextFloat() * this.field_70146_Z.nextFloat()) * 0.2D;
					}
				}

				final double d7 = (d5 * 2.0D) - 1.0D;
				this.field_70181_x += 0.03999999910593033D * d7;

				if (d5 > 0.0D) {
					f3 = (float) ((double) f3 * 0.9D);
					this.field_70181_x *= 0.8D;
				}

				this.field_70159_w *= (double) f3;
				this.field_70181_x *= (double) f3;
				this.field_70179_y *= (double) f3;
				this.func_70107_b(this.field_70165_t, this.field_70163_u, this.field_70161_v);
			}
		}
	}

	// Do we need to override this?
	@Override
	public int func_146034_e() {
		if (this.field_70170_p.field_72995_K) {
			return 0;
		} else {
			int i = 0;

			if (this.field_146043_c != null) {
				this.func_184527_k();
				this.field_70170_p.func_72960_a(this, (byte) 31);
				i = this.field_146043_c instanceof EntityItem ? 3 : 5;
			} else if (this.ticksCatchable > 0) {
				final LootContext.Builder lootcontext$builder = new LootContext.Builder((WorldServer) this.field_70170_p);
				lootcontext$builder.func_186469_a((float) EnchantmentHelper.func_151386_g(this.field_146042_b) + this.field_146042_b.func_184817_da());

				for (final ItemStack itemstack : this.field_70170_p.func_184146_ak().func_186521_a(LootTableList.field_186387_al).func_186462_a(this.field_70146_Z, lootcontext$builder.func_186471_a())) {
					final EntityItem entityitem = new EntityItem(this.field_70170_p, this.field_70165_t, this.field_70163_u, this.field_70161_v, itemstack);
					final double d0 = this.field_146042_b.field_70165_t - this.field_70165_t;
					final double d1 = this.field_146042_b.field_70163_u - this.field_70163_u;
					final double d2 = this.field_146042_b.field_70161_v - this.field_70161_v;
					final double d3 = (double) MathHelper.func_76133_a((d0 * d0) + (d1 * d1) + (d2 * d2));
					// final double d4 = 0.1D;
					entityitem.field_70159_w = d0 * 0.1D;
					entityitem.field_70181_x = (d1 * 0.1D) + ((double) MathHelper.func_76133_a(d3) * 0.08D);
					entityitem.field_70179_y = d2 * 0.1D;
					this.field_70170_p.func_72838_d(entityitem);
					this.field_146042_b.field_70170_p.func_72838_d(new EntityXPOrb(this.field_146042_b.field_70170_p, this.field_146042_b.field_70165_t, this.field_146042_b.field_70163_u + 0.5D, this.field_146042_b.field_70161_v + 0.5D, this.field_70146_Z.nextInt(6) + 1));
				}

				i = 1;
			}

			if (this.inGround) {
				i = 2;
			}

			this.func_70106_y();
			this.field_146042_b.field_71104_cf = null;
			return i;
		}
	}
}
