package com.mcmoddev.lib.integration.plugins;

import com.mcmoddev.lib.integration.IIntegration;
import com.mcmoddev.lib.material.MetalMaterial;
import com.mcmoddev.lib.util.Oredicts;

import ic2.api.item.IC2Items;
import ic2.api.recipe.RecipeInputOreDict;
import ic2.api.recipe.Recipes;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.oredict.ShapelessOreRecipe;

public class IC2 implements IIntegration {

	public static final String PLUGIN_MODID = "IC2";

	private static boolean initDone = false;

	/*
	DONE> 2* $material Item Casing made from Plate & Forge Hammer
	DONE> Crushed can be used as dust, smelted to ingot
	DONE> Purified Crushed can be used as dust, smelted to ingot

	DONE> Crushed $material ore comes from macerator (1 ore for two crushed)
	DONE> Dense plate to 8 dust in macerator

	Crushed $material can be processed in thermal centrifuge to x, Dust, and Stone Dust
	Purified Crushed $material can be processed in thermal centrifuge to x & Dust

	Crushed $material can be processed in ore washing plant to Purified Crushed, 2 tiny Dust, and stone dust

	Dense plate from 9 plate in Compressor
	2 Item Casing made from plate in metal former

	protected void allRecipes() {
		Recipes.macerator.getRecipes();
		Recipes.extractor.getRecipes();
		Recipes.compressor.getRecipes();
		Recipes.centrifuge.getRecipes();
		Recipes.blockcutter.getRecipes();
		Recipes.blastfurnace.getRecipes();
		Recipes.recycler.getRecipes();
		Recipes.metalformerExtruding.getRecipes();
		Recipes.metalformerCutting.getRecipes();
		Recipes.metalformerRolling.getRecipes();
		Recipes.oreWashing.getRecipes();
		Recipes.cannerBottle.getRecipes();
		Recipes.cannerEnrich.getRecipes();
		Recipes.electrolyzer.getRecipeMap();
		Recipes.fermenter.getRecipeMap();

		Recipes.matterAmplifier.getRecipes();
		Recipes.scrapboxDrops.getDrops();
		Recipes.recyclerBlacklist.getInputs();
		Recipes.recyclerWhitelist.getInputs();
//		Recipes.advRecipes.;
		Recipes.semiFluidGenerator.getAcceptedFluids();
		Recipes.semiFluidGenerator.getBurnProperties();
		Recipes.fluidHeatGenerator.getAcceptedFluids();
		Recipes.fluidHeatGenerator.getBurnProperties();
		Recipes.liquidCooldownManager.getAcceptedFluids();
		Recipes.liquidCooldownManager.getHeatExchangeProperties();
		Recipes.liquidHeatupManager.getAcceptedFluids();
		Recipes.liquidHeatupManager.getHeatExchangeProperties();
	}
*/

	@Override
	public void init() {
		if (initDone || !com.mcmoddev.basemetals.util.Config.Options.enableIC2) {
			return;
		}

		initDone = true;
	}

	protected void registerVanillaRecipes(MetalMaterial material) {
//		final Item forgeHammer = new ItemStack(Item.getByNameOrId("ic2:forge_hammer"), 1).getItem();
//		final Item forgeHammer = IC2Items.getItem("forge_hammer").getItem(); // crashes

//		if (forgeHammer != null) {
//			GameRegistry.addRecipe(new ShapelessOreRecipe(new ItemStack(material.casing, 2), material.plate, forgeHammer));
//		}

		// Move these to main recipe loop?
		GameRegistry.addSmelting(material.crushed, new ItemStack(material.ingot, 1), 0);
		GameRegistry.addSmelting(material.crushed_purified, new ItemStack(material.ingot, 1), 0);
		
		// TODO: Figure out Dense Plate & Casing
	}

	protected void addMaceratorRecipes(MetalMaterial material) {
		String oreDictName = material.getCapitalizedName();
		Recipes.macerator.addRecipe(new RecipeInputOreDict(Oredicts.ORE + oreDictName, 0), null, false, new ItemStack(material.crushed, 2));
		Recipes.macerator.addRecipe(new RecipeInputOreDict(Oredicts.PLATEDENSE + oreDictName, 0), null, false, new ItemStack(material.powder, 8));
	}
}
