package com.mcmoddev.lib.items;

import javax.annotation.Nullable;

import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.projectile.EntityArrow;
import net.minecraft.init.Enchantments;
import net.minecraft.init.Items;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemArrow;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.world.World;

/**
 *
 * @author Jasmine Iwanek
 *
 */
public class ItemBow extends net.minecraft.item.ItemBow {

	@Override
	public void func_77615_a(ItemStack stack, World worldIn, EntityLivingBase entityLiving, int timeLeft) {
		if (entityLiving instanceof EntityPlayer) {
			final EntityPlayer entityplayer = (EntityPlayer) entityLiving;
			final boolean flag = entityplayer.field_71075_bZ.field_75098_d || (EnchantmentHelper.func_77506_a(Enchantments.field_185312_x, stack) > 0);
			ItemStack itemstack = this.findAmmo(entityplayer);

			int i = this.func_77626_a(stack) - timeLeft;
			i = net.minecraftforge.event.ForgeEventFactory.onArrowLoose(stack, worldIn, (EntityPlayer) entityLiving, i, (itemstack != null) || flag);
			if (i < 0) {
				return;
			}

			if ((itemstack != null) || flag) {
				if (itemstack == null) {
					// TODO: FIXME Using Materials.vanilla_iron.arrow, MC uses Items.ARROW
//					itemstack = new ItemStack(Materials.vanilla_iron.arrow);
					itemstack = new ItemStack(Items.field_151032_g);
				}

				final float f = func_185059_b(i);

				if ((double) f >= 0.1D) {
					// OLD
					//final boolean flag1 = flag && (itemstack.getItem() instanceof ItemArrow); // Forge: Fix consuming custom arrows.
					// NEW
					final boolean flag1 = entityplayer.field_71075_bZ.field_75098_d || (itemstack.func_77973_b() instanceof ItemArrow ? ((ItemArrow) itemstack.func_77973_b()).isInfinite(itemstack, stack, entityplayer) : false);

					if (!worldIn.field_72995_K) {
						// TODO: FIXME Using Materials.vanilla_iron.arrow, MC uses Items.ARROW
//						final ItemArrow itemArrow = ((ItemArrow) (itemstack.getItem() instanceof ItemArrow ? itemstack.getItem() : Materials.vanilla_iron.arrow));
						final ItemArrow itemArrow = (ItemArrow) ((ItemArrow) (itemstack.func_77973_b() instanceof ItemArrow ? itemstack.func_77973_b() : Items.field_151032_g));
						final EntityArrow entityarrow = itemArrow.func_185052_a(worldIn, itemstack, entityplayer);
						entityarrow.func_184547_a(entityplayer, entityplayer.field_70125_A, entityplayer.field_70177_z, 0.0F, f * 3.0F, 1.0F);

						if (f == 1.0F) {
							entityarrow.func_70243_d(true);
						}

						final int j = EnchantmentHelper.func_77506_a(Enchantments.field_185309_u, stack);

						if (j > 0) {
							entityarrow.func_70239_b(entityarrow.func_70242_d() + ((double) j * 0.5D) + 0.5D);
						}

						final int k = EnchantmentHelper.func_77506_a(Enchantments.field_185310_v, stack);

						if (k > 0) {
							entityarrow.func_70240_a(k);
						}

						if (EnchantmentHelper.func_77506_a(Enchantments.field_185311_w, stack) > 0) {
							entityarrow.func_70015_d(100);
						}

						stack.func_77972_a(1, entityplayer);

						if (flag1) {
							entityarrow.field_70251_a = EntityArrow.PickupStatus.CREATIVE_ONLY;
						}

						worldIn.func_72838_d(entityarrow);
					}

					worldIn.func_184148_a((EntityPlayer) null, entityplayer.field_70165_t, entityplayer.field_70163_u, entityplayer.field_70161_v, SoundEvents.field_187737_v, SoundCategory.NEUTRAL, 1.0F, (1.0F / ((field_77697_d.nextFloat() * 0.4F) + 1.2F)) + (f * 0.5F));

					if (!flag1) {
						--itemstack.field_77994_a;

						if (itemstack.field_77994_a == 0) {
							entityplayer.field_71071_by.func_184437_d(itemstack);
						}
					}

					entityplayer.func_71029_a(StatList.func_188057_b(this));
				}
			}
		}
	}

	// TODO: This may not be needed
	private ItemStack findAmmo(EntityPlayer player) {
		if (this.func_185058_h_(player.func_184586_b(EnumHand.OFF_HAND))) {
			return player.func_184586_b(EnumHand.OFF_HAND);
		} else if (this.func_185058_h_(player.func_184586_b(EnumHand.MAIN_HAND))) {
			return player.func_184586_b(EnumHand.MAIN_HAND);
		} else {
			for (int i = 0; i < player.field_71071_by.func_70302_i_(); ++i) {
				final ItemStack itemstack = player.field_71071_by.func_70301_a(i);

				if (this.func_185058_h_(itemstack)) {					
					return itemstack;
				}
			}

			return null;
		}
	}

	@Override
	protected boolean func_185058_h_(@Nullable ItemStack stack) {
		// Changed ItemArrow to ItemMetalArrow
		return (stack != null) && (stack.func_77973_b() instanceof ItemMetalArrow);
	}

	// TODO: This may not be needed
	@Override
	public ActionResult<ItemStack> func_77659_a(ItemStack itemStackIn, World worldIn, EntityPlayer playerIn, EnumHand hand) {
		final boolean flag = this.findAmmo(playerIn) != null;

		if (!playerIn.field_71075_bZ.field_75098_d && !flag)
			return new ActionResult<>(EnumActionResult.FAIL, itemStackIn);
		else {
			playerIn.func_184598_c(hand);
			return new ActionResult<>(EnumActionResult.SUCCESS, itemStackIn);
		}
	}
}
