package portablejim.veinminer.api;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.common.event.FMLInterModComms;

/**
 * Helper functions to send IMC messages to VeinMiner
 */
public class IMCMessage {

	/**
	 *
	 * @param type The type to whitelist
	 * @param itemName The Item name
	 */
	public static void addTool(String type, String itemName) {
		sendWhitelistMessage("item", type, itemName);
	}

	/**
	 *
	 * @param type The type to whitelist
	 * @param blockName The block name
	 */
	public static void addBlock(String type, String blockName) {
		sendWhitelistMessage("block", type, blockName);
	}

	private static void sendWhitelistMessage(String itemType, String toolType, String blockName) {
		final NBTTagCompound message = new NBTTagCompound();
		message.func_74778_a("whitelistType", itemType);
		message.func_74778_a("toolType", toolType);
		message.func_74778_a("blockName", blockName);
		FMLInterModComms.sendMessage("VeinMiner", "whitelist", message);
	}

	/**
	 *
	 * @param type The type to add
	 * @param name The name
	 * @param icon The icon
	 */
	public static void addToolType(String type, String name, String icon) {
		final NBTTagCompound message = new NBTTagCompound();
		message.func_74778_a("toolType", type);
		message.func_74778_a("toolName", name);
		message.func_74778_a("toolIcon", icon);
		FMLInterModComms.sendMessage("VeinMiner", "addTool", message);
	}

	/**
	 *
	 * @param existingBlock The existing block
	 * @param newBlock The new block
	 */
	public static void addBlockEquivalence(String existingBlock, String newBlock) {
		final NBTTagCompound message = new NBTTagCompound();
		message.func_74778_a("existingBlock", existingBlock);
		message.func_74778_a("newBlock", newBlock);
		FMLInterModComms.sendMessage("VeinMiner", "addEqualBlocks", message);
	}
}
